

import sys

from define import *


class Config:

    def __init__(self, filename=''):
        self.defaults()
        if filename != '':
            ret = self.load(filename)
            if not ret:
                self.save(filename)

    def defaults(self):
        self.view_xx = SCR_XX[0]
        self.view_yy = SCR_XX[1]
        self.mouse_sens = 1.0
        self.music = 1

    def load(self, filename):
        try:
            f = open(filename)
        except IOError:
            return False
        data = f.read()
        f.close()

        data = data.split()
        i = 0
        while i < len(data):
            if data[i] == 'screen':
                self.view_xx = int(data[i+1])
                self.view_yy = int(data[i+2])
                i += 3
            elif data[i] == 'music':
                self.music = int(data[i+1])
                i += 2
            elif data[i] == 'mouse_sens':
                self.mouse_sens = float(data[i+1])
                i += 2
            else:
                print('error: unknown options tag: ' + data[i])
                i += 1
        return True

    def save(self, filename=FN_CFG):
        f = open(filename, 'w')
        f.write('screen ' + str(self.view_xx) + ' ' + str(self.view_yy) + '\n')
        f.write('music ' + str(self.music) + '\n')
        f.write('mouse_sens ' + str(self.mouse_sens) + '\n')
        f.close()


