
import sys

import pygame
from pygame.locals import *

from glarray import *
from define import *
from OpenGL.GL import *


# Pause state.
class StatePause:

    def __init__(self, core):
        self.core = core
        self.keys = self.core.keys
        self.tex_hud = self.core.tex_hud
        pygame.mouse.set_visible(True)
        pygame.event.set_grab(False)


    def step(self):
        if (self.keys[KEY_ENTER] % 2):
            sys.exit(0)
        if (self.keys[KEY_ESC] == 3):
            pygame.mouse.set_visible(False)
            pygame.event.set_grab(True)
            pygame.mixer.unpause()
            pygame.mixer.music.unpause()
            # Pop self from the state stack.
            self.core.states.pop()
        self.drawScreen()


    def drawScreen(self):
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
        tex = self.tex_hud
        tex.bind()

        glColor3f(1.0, 1.0, 1.0)
        glDisable(GL_DEPTH_TEST)
        glPushMatrix()
        glLoadIdentity()
        vertices = [] 
        texcoords = []

        vertices += [0.5, 0.25, -1.0, -0.5, 0.25, -1.0,
                -0.5, -0.25, -1.0, 0.5, -0.25, -1.0]
        texcoords += tex.select((0,4),(4,2))

        n = len(vertices)/3
        vertices = glarray(vertices)
        texcoords = glarray(texcoords)
        glVertexPointer(3,GL_FLOAT,0,vertices)
        glTexCoordPointer(2,GL_FLOAT,0,texcoords)
        glDrawArrays(GL_QUADS,0,n)
        glPopMatrix()
        glEnable(GL_DEPTH_TEST)

        pygame.display.flip()


