

import math
import random

from define import *
from Thing import Thing
from Sprite import Sprite
from ThingImpact import ThingImpact
from ThingHurt import ThingHurt
from ThingAni import ThingAni
from Sfx import Sfx


class ThingBossProj(Thing):


    ACC = 1.0/512


    def __init__(self, main, pos, target, parent):
        Thing.__init__(self, main, pos)
        self.target = list(target)
        if self.main.hardmode:
            self.ACC *= 2
            self.target[0] += random.uniform(-2.0,2.0)
            self.target[1] += random.uniform(-2.0,2.0)
        self.parent = parent
        self.dir[0] = self.getTargetDir()
        self.acc = [0]*2
        self.acc[0] = self.ACC * math.cos(float(self.dir[0]))
        self.acc[1] = self.ACC * math.sin(float(self.dir[0]))
        self.nrg = 256
        self.box[0] = 0.125
        self.main.things_destr.add(self)
        Sfx(self.main, 'boss_proj.ogg', self)


    def damage(self, nrg):
        self.nrg = 0
        ThingAni(self.main, self.pos, (13,0), 3, 8)
        Sfx(self.main, 'bullet_impact.ogg', self)


    def step(self):
        if self.nrg == 0: return
        self.nrg -= 1
        self.sp[0] += self.acc[0]
        self.sp[1] += self.acc[1]
        if self.moveSolid(3, set([self.parent])):
            ThingHurt(self.main, self.pos, 1.0)
            self.nrg = 0
            ThingAni(self.main, self.pos, (13,0), 3, 8)
            Sfx(self.main, 'bullet_impact.ogg', self)
        else: 
            Sprite(self.main, self.pos, (11+(self.nrg/4)%2,0))



