
import math
import random

from Thing import Thing
from Sprite import Sprite
from ThingAni import ThingAni
from ThingHurt import ThingHurt
from Sfx import Sfx


# Spray attack, small annoying projectile.
class ThingBossSpray(Thing):


    SP = 1.0/12
    SFX = [ 
            'spray1.ogg', 
            'spray2.ogg',
            'spray3.ogg',
    ]


    def __init__(self, main, pos, dir, parent):
        Thing.__init__(self, main, pos, dir)
        self.pos[2] += random.uniform(-0.25, 0.25)
        self.parent = parent
        self.sp[0] = self.SP * math.cos(float(self.dir[0]))
        self.sp[1] = self.SP * math.sin(float(self.dir[0]))
        self.nrg = 256
        self.box[0] = 0.0625
        self.ani_off = random.randint(0,7)
        Sfx(self.main, random.choice(self.SFX), self)
        

    def step(self):
        self.nrg -= 1
        if self.moveSolid(3, set([self.parent])):
            ThingHurt(self.main, self.pos, 0.50)
            self.nrg = 0
        else: 
            sprx = 12+(self.main.step_i+self.ani_off)%8/2
            Sprite(self.main, self.pos, (sprx,4))



