


import math
import random

from Thing import Thing
from Sprite import Sprite
from ThingImpact import ThingImpact
from ThingAni import ThingAni
from Sfx import Sfx


class ThingBounce(Thing):


    SP = 1.0/4
    DMG = 2

    SFX = [ 
            'bounce1.ogg', 
            'bounce2.ogg', 
            'bounce3.ogg', 
            'bounce4.ogg', 
            'bounce5.ogg', 
            'bounce6.ogg', 
            'bounce7.ogg', 
            'bounce8.ogg'
    ]

    def __init__(self, main, pos, dir):
        Thing.__init__(self, main, pos, dir)
        self.sp[0] = self.SP * math.cos(float(self.dir[0]))
        self.sp[1] = self.SP * math.sin(float(self.dir[0]))
        self.nrg = 256
        self.box[0] = 0.0625
        self.bounce_i = 0
        self.spr_off = random.randint(0,3)
        

    def step(self):
        self.nrg -= 1
        destr = self.collideDestr()
        if len(destr) >= 1:
            self.nrg = 0
            destr[0].damage(self.DMG)
            Sfx(self.main, self.SFX[self.bounce_i % len(self.SFX)], self)
        if self.bounceSolid(3,set([self.main.pc]) | self.main.things_destr):
            ThingAni(self.main, self.pos[:2]+[0.375], (6,2), 3, 4)
            Sfx(self.main, self.SFX[self.bounce_i % len(self.SFX)], self)
            self.bounce_i += 1
        if self.nrg <= 0:
            ThingAni(self.main, self.pos[:2]+[0.375], (6,2), 3, 4)
        spr_i = (self.spr_off + self.nrg)%4
        Sprite(self.main, self.pos, (9+spr_i,6))



