

from Thing import Thing
from Sprite import Sprite

class ThingConfigMouse(Thing):

    SETTINGS = [0.3, 0.5, 0.7, 1.0, 1.3, 1.6, 2.0, 2.5]

    # Args: [pos_x, pos_y]
    def __init__(self, main, args):
        Thing.__init__(self, main, args[:2])
        self.box[0] = 0.375
        try:
            self.setting = self.SETTINGS.index(self.main.core.config.mouse_sens)
        except ValueError:
            self.setting = 3
        self.main.things_solid.add(self)
        self.main.things_destr.add(self)


    def damage(self, nrg):
        self.setting += 1
        self.setting %= len(self.SETTINGS)
        self.main.core.config.mouse_sens = self.SETTINGS[self.setting]
        self.main.core.config.save()


    def step(self):
        Sprite(self.main, self.pos, (3+self.setting,9))


