

import random


from Thing import Thing
from ThingAni import ThingAni
from define import *


class ThingDeadBoss(Thing):


    def __init__(self, main, pos):
        Thing.__init__(self, main, pos)
        self.nrg = 256
        # Initial explosion
        ThingAni(self.main, self.pos[:2]+[0.5], (5,7), 3, 16)
        for i in range(5):
            x = self.pos[0] + random.uniform(-1,1)
            y = self.pos[1] + random.uniform(-1,1)
            ThingAni(self.main, [x,y,0.5], (5,7), 3, 16-1-i)
        for t in self.main.things_destr:
            if self.canSee(t):
                x = t.pos[0] + random.uniform(-0.1,0.1)
                y = t.pos[1] + random.uniform(-0.1,0.1)
                ThingAni(self.main, [x,y,0.5], (5,7), 3, 16-1-i)
                t.damage(100)
                self.main.flash = [1.0, 1.0, 1.0, 1.0]


    def step(self):
        self.nrg -= 1
        if self.nrg == 0:
            self.main.nextmap = "endgame"
        if self.nrg >= 64:
            # Extra explosions
            x = self.pos[0] + random.uniform(-8,8)
            y = self.pos[1] + random.uniform(-8,8)
            ThingAni(self.main, [x,y,0.5], (5,7), 3, 16)
            if random.randint(0,15) == 0:
                self.main.flash = [1.0, 1.0, 1.0, 0.25]




