
from define import *

from Thing import Thing
from Sprite import Sprite
from Sfx import Sfx


class ThingDoor(Thing):


    SINK_SP = 1.0/32


    # args: [pos_x, pos_y, key_id]
    def __init__(self, main, args):
        Thing.__init__(self, main, args[:2])
        self.box[0] = 1.5
        self.num = int(args[2])
        if (self.num == 0 and self.main.map.filename == LEVEL_HUB and 
                (tuple(map(int,self.pos[:2])) in self.main.mapkeys[0])):
            # Destroy door if it is an already opened hub door
            self.nrg = 0
            return
        self.main.map.get(map(int,self.pos[:2])).solid = 2


    def step(self):
        Sprite(self.main, self.pos, (5+self.num,1))
        if (self.num == 0):
            if (self.sp[2] == 0.0 and ((-1,-1) in self.main.mapkeys[0]) and 
                    self.collide(self.main.pc)):
                self.sp[2] = -self.SINK_SP
                self.main.flash = [1.0, 1.0, 1.0, 0.25]
                Sfx(self.main, 'door_unlock.ogg', self)
                i = self.main.mapkeys[0].index((-1,-1))
                self.main.mapkeys[0][i] = tuple(map(int,self.pos[:2]))

        else:
            if (self.sp[2] == 0.0 and self.main.mapkeys[self.num] and 
                    self.collide(self.main.pc)):
                # Door opened, sink into the ground.
                self.sp[2] = -self.SINK_SP
                self.main.flash = [1.0, 1.0, 1.0, 0.25]
                Sfx(self.main, 'door_unlock.ogg', self)
        self.move()
        if self.pos[2] <= -0.5:
            # Door is underground now and can be destroyed.
            self.main.map.get([int(i) for i in self.pos[:2]]).solid = 0
            self.nrg = 0
