
import math
import random

from Thing import Thing
from Sprite import Sprite
from ThingImpact import ThingImpact
from ThingAni import ThingAni
from ThingHurt import ThingHurt
from Sfx import Sfx


class ThingDragonProj(Thing):


    SP = 1.0/4


    def __init__(self, main, pos, dir, parent):
        Thing.__init__(self, main, pos, dir)
        self.parent = parent
        self.sp[0] = self.SP * math.cos(float(self.dir[0]))
        self.sp[1] = self.SP * math.sin(float(self.dir[0]))
        self.nrg = 256
        self.box[0] = 0.0625
        self.ani_off = random.randint(0,7)
        

    def step(self):
        self.nrg -= 1
        if self.moveSolid(3, set([self.parent])):
            ThingHurt(self.main, self.pos, 0.50)
            Sfx(self.main, 'bullet_impact.ogg', self)
            self.nrg = 0
        else: 
            sprx = 4+(self.main.step_i+self.ani_off)%8/2
            Sprite(self.main, self.pos, (sprx,6))



