

from Thing import Thing


class ThingEntrance(Thing):

    # args: [pos_x, pos_y, next_level]
    def __init__(self, main, args):
        Thing.__init__(self, main, args[:2])
        self.box[0] = 0.375
        self.lev = args[2]
        if self.lev in self.main.finmaps:
            # Map already finished, deactivate the entrance
            self.main.map.get([int(i) for i in self.pos[:2]]).spr = (1,2)
            self.nrg = 0
        else:
            self.main.map.get([int(i) for i in self.pos[:2]]).spr = (0,2)


    def step(self):
        if self.nrg > 0 and self.collide(self.main.pc):
            # Move to level from hub.
            self.main.hubpc = {'pos': self.pos, 'dir': self.main.pc.dir}
            self.main.nextmap = self.lev
            self.main.prevammo = list(self.main.ammo)
            self.main.prevhubkeys = list(self.main.mapkeys[0])


