


import random
import math

from Thing import Thing
from Sprite import Sprite
from ThingImpact import ThingImpact
from ThingAni import ThingAni
from ThingHurt import ThingHurt
from Sfx import Sfx


class ThingFlowerProj(Thing):


    SP = 1.0/4


    def __init__(self, main, pos, target, parent):
        Thing.__init__(self, main, pos)
        self.target = list(target)
        if self.main.hardmode:
            self.target[0] += random.uniform(-2.0, 2.0)
            self.target[1] += random.uniform(-2.0, 2.0)
        self.parent = parent
        self.dir[0] = self.getTargetDir()
        self.sp[0] = self.SP * math.cos(float(self.dir[0]))
        self.sp[1] = self.SP * math.sin(float(self.dir[0]))
        self.nrg = 256
        self.box[0] = 0.0625
        Sfx(self.main, 'flower_fire.ogg', self)
        

    def step(self):
        self.nrg -= 1
        if self.moveSolid(3, set([self.parent])):
            ThingHurt(self.main, self.pos, 0.25)
            Sfx(self.main, 'bullet_impact.ogg', self)
            ThingAni(self.main, self.pos, (13,5), 3, 8)
            self.nrg = 0
        else: 
            Sprite(self.main, self.pos, (3,5))



