
from define import *

from Thing import Thing
from Sprite import Sprite
from Sfx import Sfx



class ThingKey(Thing):


    # args: [pos_x, pos_y, key_id]
    # Keys with id 0 are hub keys, which are kept on level change, but removed 
    # when used on a door. The other keys are kept when used, but removed at 
    # the end of a level.
    def __init__(self, main, args):
        Thing.__init__(self, main, args[:2])
        self.num = int(args[2])
        self.spr = (self.num,1)
        self.pos[2] = 0.5
        self.box[0] = 0.5


    def step(self):
        if self.collide(self.main.pc):
            # PC has collected key.
            self.nrg = 0
            self.main.flash = [1.0, 1.0, 0.0, 0.25]
            if self.num == 0:
                self.main.mapkeys[0].append((-1,-1))
                Sfx(self.main, 'key_white.ogg', None)
            else:
                self.main.mapkeys[self.num] += 1
                Sfx(self.main, 'key.ogg', None)
        Sprite(self.main, self.pos, self.spr)

