

import math

from Thing import Thing
from Sprite import Sprite
from ThingImpact import ThingImpact
from ThingAni import ThingAni
from Sfx import Sfx


class ThingLaser(Thing):


    SP = 1.0/4
    DMG = 3


    def __init__(self, main, pos, dir):
        Thing.__init__(self, main, pos, dir)
        self.sp[0] = self.SP * math.cos(float(self.dir[0]))
        self.sp[1] = self.SP * math.sin(float(self.dir[0]))
        self.nrg = 256
        self.box[0] = 0.0625
        

    def step(self):
        self.nrg -= 1
        destr = self.collideDestr()
        if len(destr) >= 1:
            self.nrg = 0
            destr[0].damage(self.DMG)
            ThingAni(self.main, self.pos[:2]+[0.375], (2,2), 3, 8)
            Sfx(self.main, 'bullet_impact.ogg', self)
        if self.bounceSolid(3,set([self.main.pc]) | self.main.things_destr):
            self.nrg = 0
            ThingAni(self.main, self.pos[:2]+[0.375], (2,2), 3, 8)
            Sfx(self.main, 'bullet_impact.ogg', self)
        else: 
            ThingAni(self.main, self.pos, (1,2), 1, 4)
            Sprite(self.main, self.pos, (1,2))



