


import math
import random

from Thing import Thing
from Sprite import Sprite
from ThingImpact import ThingImpact
from ThingAni import ThingAni
from Sfx import Sfx


class ThingTv(Thing):


    SP = 1.0/4
    SP_Z = 1.0/8
    GRAV = 1.0/56
    DMG = 50
    SPLASH = 20


    def __init__(self, main, pos, dir):
        Thing.__init__(self, main, pos, dir)
        self.sp[0] = self.SP * math.cos(float(self.dir[0]))
        self.sp[1] = self.SP * math.sin(float(self.dir[0]))
        self.nrg = 16
        self.box[0] = 0.0625
        self.sp[2] = self.SP_Z
        

    def kaboom(self):
        ThingAni(self.main, self.pos[:2]+[0.5], (5,7), 3, 16)
        Sfx(self.main, 'tv_explode.ogg', self, 2.0)
        for i in range(5):
            x = self.pos[0] + random.uniform(-1,1)
            y = self.pos[1] + random.uniform(-1,1)
            ThingAni(self.main, [x,y,0.5], (5,7), 3, 16-1-i)
        for t in self.main.things_destr:
            if self.canSee(t):
                x = t.pos[0] + random.uniform(-0.1,0.1)
                y = t.pos[1] + random.uniform(-0.1,0.1)
                ThingAni(self.main, [x,y,0.5], (5,7), 3, 16-1-i)
                t.damage(self.SPLASH)
            


    def step(self):
        self.nrg -= 1
        self.sp[2] -= self.GRAV
        destr = self.collideDestr()
        if self.nrg <= 0:
            self.kaboom()
        if len(destr) >= 1:
            self.nrg = 0
            destr[0].damage(self.DMG)
            self.kaboom()
        if self.bounceSolid(3,set([self.main.pc]) | self.main.things_destr):
            self.nrg = 0
            self.kaboom()
        else: 
            Sprite(self.main, self.pos, (13,2))



