

import math
import random

from Thing import Thing
from Sprite import Sprite


# Wave moving up and down.
class ThingWave(Thing):

    # args: [pos_x, pos_y]
    def __init__(self, main, args):
        Thing.__init__(self, main, args)
        self.center = list(self.pos)
        self.baseheight = (self.main.map.getHeight(
                [int(i) for i in self.pos[:2]]) + 0.5)
        self.pos[0] = self.center[0]+random.uniform(-1,1)
        self.pos[1] = self.center[1]+random.uniform(-1,1)
        self.cycle = random.randint(0,256)


    def step(self):
        self.pos[2] = (self.baseheight - 0.125 - 
                0.125*math.cos(self.cycle/128.0*math.pi))
        if self.cycle == 0:
            # Randomly move the wave around a bit when not visible.
            self.pos[0] = self.center[0]+random.uniform(-1,1)
            self.pos[1] = self.center[1]+random.uniform(-1,1)
        if 64 <= self.cycle < 192:
            Sprite(self.main, self.pos, (0,2))
        self.cycle += 1
        self.cycle %= 256

