


import math

from define import *
from ThingImpact import ThingImpact
from Sfx import Sfx

class WeaponRake:


    DMG = 5


    def __init__(self, main):
        self.main = main
        self.ani = 0
        self.tag = WEAPON_RAKE


    def attack(self):
        if self.ani > 0: return
        self.ani = 32
        pc = self.main.pc
        x = pc.pos[0] + 0.5*math.cos(pc.dir[0])
        y = pc.pos[1] + 0.5*math.sin(pc.dir[0])
        Sfx(self.main, 'rake_swing.ogg', None)
        ThingImpact(self.main, [x,y,0.5], 0.25, 16, self.DMG)


    def draw(self, ybot, vertices, texcoords):
        if self.ani <= 0:
            if self.main.cheat: return
            x = 0.5
            y = ybot + 0.25
        elif self.ani > 16:
            t = 32-self.ani
            x = 0.5-0.25*t
            y = ybot+0.25-0.015625*t**2
        else:
            t = self.ani
            x = 0.5+0.0625*t
            y = ybot+0.25-0.0625*t
        self.ani -= 1

        vertices += [x+0.5, y+0.5, -1.0, x-0.5, y+0.5, -1.0,
                x-0.5, y-0.5, -1.0, x+0.5, y-0.5, -1.0]
        tex = self.main.tex_hud
        texcoords += tex.select((0,0),(2,2))



