

import math

from define import *
from ThingSpread import ThingSpread
from Sfx import Sfx


class WeaponSpread:


    SPREAD = math.pi/8.0


    def __init__(self, main):
        self.main = main
        self.ani = 0
        self.tag = WEAPON_SPREAD

    def attack(self):
        if self.ani > 0: return
        self.ani = 32
        self.main.ammo[self.tag] -= 1
        pcdir = self.main.pc.dir[0]
        for i in [-2,-1,0,1,2]:
            d = [pcdir+i*self.SPREAD]
            t = -float(i)*math.pi/256.0
            ThingSpread(self.main, self.main.pc.pos, d, t)
            Sfx(self.main, 'spread_fire.ogg', None)

    def draw(self, ybot, vertices, texcoords):
        if self.ani > 0: 
            self.ani -= 1
        x = 0.0
        y = ybot+0.5
        vertices += [x+0.5, y+0.5, -1.0, x-0.5, y+0.5, -1.0,
                x-0.5, y-0.5, -1.0, x+0.5, y-0.5, -1.0]
        tex = self.main.tex_hud
        texcoords += tex.select((6,0),(2,2))


