

# Default screen size. 
SCR_XX = (1024, 768)
# Step frequency (or frames per second)
STEP_FREQ = 60

# Keyboard key enumeration.
KEY_ESC = 0
KEY_ENTER = 1
KEY_UP = 2
KEY_LEFT = 3
KEY_DOWN = 4
KEY_RIGHT = 5
KEY_FIRE = 6
KEY_MAP = 7
KEY_CHEAT = 8
KEY_1 = 9
KEY_2 = 10
KEY_3 = 11
KEY_4 = 12
KEY_5 = 13
KEY_N = 14 # Amount of keys.

# Texture unit size. 
# Sprites used in the game (as well as wall/floor textures) are typically 
# TEX_XX * TEX_XX in dimensions.
TEX_XX = 32

# Data directory name, used for all data files (textures, sounds, levels)
DATA_DIR = 'data'

# Hub map name, the map returned to after each level.
LEVEL_HUB = 'hub.lev'

# Save file name
FN_SAVE = 'save'

# Config file name
FN_CFG = 'config'

# Weapon enumeration
WEAPON_RAKE = 0
WEAPON_LASER = 1
WEAPON_SPREAD = 2
WEAPON_BOUNCE = 3
WEAPON_TV = 4
WEAPON_N = 5

# Screencap rate, 0 to turn off
SCREENCAP = 0

# Bound a value by a, b.
def bound(x, a, b):
    if (x < a): return a
    elif (x > b): return b
    else: return x

# Dot product
def dot(a, b):
    return a[0]*b[0] + a[1]*b[1]

